﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.ChartView;

namespace wpf_ChartView_755202_2
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            DataContext = new ViewModel();
        }
    }

    public class DataPoint
    {
        public DateTime Date { get; set; }
        public double Value { get; set; }
    }

    public class SeriesBase
    {
        public ObservableCollection<DataPoint> Data { get; set; }
        public Type SeriesType { get { return this.SeriesTypeOverride; } }
        public virtual Type SeriesTypeOverride { get { return null; } }
    }

    public class PointData : SeriesBase
    {
        public override Type SeriesTypeOverride { get { return typeof(BarSeries); } }
    }

    public class LineData : SeriesBase
    {
        public override Type SeriesTypeOverride { get { return typeof(LineSeries); } }
    }

    public class ViewModel
    {
        private Random _Random;
        private ObservableCollection<SeriesBase> _Series;
        public ObservableCollection<SeriesBase> Series { get { return _Series; } }
        public ViewModel()
        {
            _Random = new Random();
            _Series = new ObservableCollection<SeriesBase>();
            _Series.Add(new PointData() { Data = GenerateSomeData() });
            _Series.Add(new LineData() { Data = GenerateSomeData() });
        }

        private ObservableCollection<DataPoint> GenerateSomeData()
        {
            ObservableCollection<DataPoint> newCollection = new ObservableCollection<DataPoint>();
            for (int i = 0; i < 10; i++)
                newCollection.Add(new DataPoint() { Date = new DateTime(2012, 12, 31).AddDays(i), Value = _Random.Next(100) });
            return newCollection;
        }
    }
}
